//------------------------------------------------------------------------------
// :     getdxversetup.dpr
//
// :      DirectX
//
//
// ,     , 2002
//------------------------------------------------------------------------------
program getdxversetup;

uses
  windows,
  messages,
  sysutils,
  directsetup;




//------------------------------------------------------------------------------
// ,    
//------------------------------------------------------------------------------
var
  dwVersion:  DWORD = 0;
  dwRevision: DWORD = 0;
  strDXVer:   string;

function DirectXSetupGetVersion( pdwVersion, pdwRevision: PDWORD): Integer; stdcall; external 'dsetup.dll' name 'DirectXSetupGetVersion';




//------------------------------------------------------------------------------
// :      ()
// :    
//------------------------------------------------------------------------------
begin
  if DirectXSetupGetVersion( @dwVersion, @dwRevision ) = 0 then
     Exit;

  case dwVersion of
    $00040001: strDXVer := ' Game SDK (DirectX 1)';
    $00040002: strDXVer := ' DirectX 2';
    $00040003: strDXVer := ' DirectX 3';
    $00040005: strDXVer := ' DirectX 5';
    $00040006: strDXVer := ' DirectX 6';
    $00040007: strDXVer := ' DirectX 7';
    $00040008: strDXVer := ' DirectX 8  ';
  else
    strDXVer := 'DirectX  ';
  end;

  strDXVer := strDXVer + #10 + Format( ': %d.0%d.0%d.0%d',
                                       [ HIWORD( dwVersion ),
                                         LOWORD( dwVersion ),
                                         HIWORD( dwRevision ),
                                         LOWORD( dwRevision ) ] );
                                         
  MessageBox( 0, PChar(strDXVer), ' DirectX', MB_ICONINFORMATION );
end.
