//------------------------------------------------------------------------------
// :     getpixformat.dpr
//
// :   
//
//
// ,     , 2002
//------------------------------------------------------------------------------
program getpixformat;

uses
  windows,
  sysutils,
  directdraw;




//------------------------------------------------------------------------------
//    
//------------------------------------------------------------------------------
var
  pDD7:     IDirectDraw7        = nil; 
  pSurface: IDirectDrawSurface7 = nil;

  ddsd2: TDDSURFACEDESC2;
  ddpf:  TDDPIXELFORMAT;




//------------------------------------------------------------------------------
// :      ()
// :    
//------------------------------------------------------------------------------
begin
  //    DirectDraw
  if FAILED( DirectDrawCreateEx( nil, pDD7, IID_IDirectDraw7, nil ) ) then
     Exit;

  //   
  if FAILED( pDD7.SetCooperativeLevel( 0, DDSCL_NORMAL ) ) then
     Exit;

  //   TDDSURFACEDESC2
  ZeroMemory( @ddsd2, SizeOf( TDDSURFACEDESC2 ) );
  with ddsd2 do
  begin
    dwSize         := SizeOf( TDDSURFACEDESC2 );
    dwFlags        := DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT;
    ddsCaps.dwCaps := DDSCAPS_OFFSCREENPLAIN;
    dwWidth        := 1;
    dwHeight       := 1;
  end;

  //  
  if FAILED( pDD7.CreateSurface( ddsd2, pSurface, nil ) ) then
     Exit;

  //   TDDPIXELFORMAT
  ZeroMemory( @ddpf, SizeOf( TDDPIXELFORMAT ) );
  ddpf.dwSize := SizeOf( TDDPIXELFORMAT );

  //   
  if FAILED( pSurface.GetPixelFormat( ddpf ) ) then
     Exit;

  //  
  MessageBox( 0, PChar('R: ' + IntToHex( ddpf.dwRBitMask, 8 ) + #10 +
                       'G: ' + IntToHex( ddpf.dwGBitMask, 8 ) + #10 +
                       'B: ' + IntToHex( ddpf.dwBBitMask, 8 )), '', MB_OK );

  pSurface := nil;
  pDD7 := nil;
end.
