//------------------------------------------------------------------------------
// :     transparent.dpr
//
// :    
//
//
// ,     , 2002
//------------------------------------------------------------------------------
program transparent;

uses
  windows,
  messages,
  basedd7 in 'basedd7.pas';




//------------------------------------------------------------------------------
// ,    
//------------------------------------------------------------------------------
var
  wc:       WNDCLASSEX;
  hMainWnd: HWND;
  msg:      TMSG;

  nPosX: Integer = ( 640 - 100 ) div 2;
  nPosY: Integer = ( 480 - 100 ) div 2; //  




//------------------------------------------------------------------------------
// :      MsgProc()
// :  
//------------------------------------------------------------------------------
function MsgProc( hWnd: HWND; msg: UINT; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall;
begin
  case msg of
    WM_KEYDOWN:
    case wParam of
      VK_LEFT:   Dec( nPosX, 5 );
      VK_RIGHT:  Inc( nPosX, 5 );
      VK_UP:     Dec( nPosY, 5 );
      VK_DOWN:   Inc( nPosY, 5 );
      VK_ESCAPE: SendMessage( hWnd, WM_DESTROY, 0, 0 );
    end;

    WM_DESTROY:
    begin
      PostQuitMessage( 0 );
      Result := 0;
    end;
  end;

  Result := DefWindowProc( hWnd, msg, wParam, lParam );
end;




//------------------------------------------------------------------------------
// :      ()
// :    
//------------------------------------------------------------------------------
begin
  wc.cbSize        := SizeOf( WNDCLASSEX );
  wc.lpfnWndProc   := @MsgProc;
  wc.hInstance     := GetModuleHandle( 0 );
  wc.hCursor       := LoadCursor( 0, IDC_ARROW );
  wc.lpszClassName := 'DDDemo';

  RegisterClassEx( wc );
  hMainWnd := CreateWindowEx( WS_EX_TOPMOST, 'DDDemo', 'Noname', WS_POPUP,
                              0, 0, 0, 0, 0, 0, wc.hInstance, nil );


  if ( InitDirectDraw( hMainWnd, 640, 480, 16 ) ) and
     ( LoadFiles( hMainWnd ) ) then
  begin
    ShowWindow( hMainWnd, SW_SHOWDEFAULT );
    UpdateWindow( hMainWnd );

    while msg.message <> WM_QUIT do
    if PeekMessage( msg, 0, 0, 0, PM_REMOVE ) then
    begin
      TranslateMessage( msg );
      DispatchMessage( msg );
    end
    else OnDraw( nPosX, nPosY );
  end;

  ReleaseDirectDraw();
  UnregisterClass( 'DDDemo', wc.hInstance );
end.
